\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
read("terdragon-defines.gp")

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

P1_formula(k)  = -1/24 * (b^k + p(k));
P1(k)  = if(k<6, error(),  P1_formula(k));

gp_inline__location="more.tex:1322";
P2_formula(k)  = -1/24 * (b^(k+1) + p(k+1));
P2(k)  = if(k<6, error(),  P2_formula(k));

gp_inline__location="more.tex:1328";
P3_formula(k)  = -1/24 * (b^(k+2) + p(k+2));
P3(k)  = if(k<6, error(),  P3_formula(k));

gp_inline__location="more.tex:1334";
P4_formula(k)  = -1/24 * (b^(k+3) + p(k+3));
P4(k)  = if(k<6, error(),  P4_formula(k));

gp_inline__location="more.tex:1340";
P5_formula(k)  = -1/24 * (b^(k+4) + p(k+4));
P5(k)  = if(k<6, error(),  P5_formula(k));

gp_inline__location="more.tex:1346";
P6_formula(k) = -1/24 * b^(k+5) - 1/24*p(k+5);
P6(k)  = if(k<6, error(),  P6_formula(k));

gp_inline__location="more.tex:1357";
P7_formula(k) = -1/24*( (1+1/9*w6)*b^(k+5) + p(k+6) );
P7(k)  = if(k<6, error(),  P7_formula(k));

gp_inline__location="more.tex:1399";
p_vector = {[
-9,        6+15*w3,        -3-3*w3,        -3-6*w3,
(-9)*w3,   (6+15*w3)*w3,   (-3-3*w3)*w3,   (-3-6*w3)*w3,
(-9)*w3^2, (6+15*w3)*w3^2, (-3-3*w3)*w3^2, (-3-6*w3)*w3^2
]};
p(m) = vector_modulo(p_vector,m);

gp_inline__location="more.tex:1432";
P1dash(k) = b^k - P1(k);
P2dash(k) = b^k - P2(k);
P3dash(k) = b^k - P3(k);
P4dash(k) = b^k - P4(k);
P5dash(k) = b^k - P5(k);
P6dash(k) = b^k - P6(k);
P7dash(k) = b^k - P7(k);

\\-----------------------------------------------------------------------------

P1a(k) = P1(k-1);
P2a(k) = P2(k-1);
P4b_dash(k) = b^(k-1) + w3*P4dash(k-1);

P1_rel(k) = (P4b_dash(k)-P2a(k)) / (P1a(k)-P2a(k));
{
check_exact(vector(100,k,k+=6; (P4b_dash(k)-P2a(k)) / (P1a(k)-P2a(k))),
            vector(100,k,k+=6; P1_rel(k)));
}
{
check_exact(vector(100,k,k+=6; (b^(k-1) + w3*P4dash(k-1)-P2(k-1)) / (P1(k-1)-P2(k-1))),
            vector(100,k,k+=6; P1_rel(k)));
}
{
check_exact(vector(100,k,k+=6; (b^(k-1) + w3*(b^(k-1) - (-1/24) * (b^(k+2) + p(k+2)))
                                - (-1/24) * (b^(k) + p(k)))
                   / (-1/24 * (b^(k-1) + p(k-1)) - (-1/24) * (b^(k) + p(k)))),
            vector(100,k,k+=6; P1_rel(k)));
}
{
check_exact(vector(100,k,k+=6; (24*b^(k-1) + 24*w3*b^(k-1) + w3 * (b^(k+2) + p(k+2))
                                + b^(k) + p(k))
                   / (- (b^(k-1) + p(k-1)) + b^(k) + p(k))),
            vector(100,k,k+=6; P1_rel(k)));
}
{
check_exact(vector(100,k,k+=6; (24/b*b^k + 24*w3/b*b^k + b^k + w3*b^2 * b^k
                                + p(k+6) + p(k))
                   / ( b^k - b^(k-1) + p(k) - p(k-1))),
            vector(100,k,k+=6; P1_rel(k)));
}
{
check_exact(vector(100,k,k+=6; ((24/b + 24*w3/b + 1 + w3*b^2) * b^k
                                + p(k+6) + p(k))
                   / ( b^k - b^(k-1) + p(k) - p(k-1))),
            vector(100,k,k+=6; P1_rel(k)));
}
{
check_exact(vector(100,k,k+=6;
                   ((14 + 8*w3) * b^k + p(k+6) + p(k))
                   / ( (1-1/b) * b^k + p(k) - p(k-1))),
            vector(100,k,k+=6; P1_rel(k)));
}
{
check_exact(vector(100,k,k+=6;
                   (14+8*w3)/(1-1/b) 
                   + ((14 + 8*w3) * b^k + p(k+6) + p(k)
                      - (14+8*w3)/(1-1/b) * ( (1-1/b) * b^k + p(k) - p(k-1))
                     )
                   / ( (1-1/b) * b^k + p(k) - p(k-1))),
            vector(100,k,k+=6; P1_rel(k)));
}
{
check_exact(vector(100,k,k+=6;
                   22 + 2*w3
                   + ((14 + 8*w3) * b^k + p(k+6) + p(k)
                      - (14+8*w3)/(1-1/b) *(1-1/b) * b^k
                      - (14+8*w3)/(1-1/b) *(+ p(k) - p(k-1))
                     )
                   / ( (1-1/b) * b^k + p(k) - p(k-1))),
            vector(100,k,k+=6; P1_rel(k)));
}
{
check_exact(vector(100,k,k+=6;
                   22 + 2*w3
                   + (
                      p(k+6) + p(k) - (22 + 2*w3) *p(k) + (22 + 2*w3) *p(k-1)
                     )
                   / ( (1-1/b) * b^k + p(k) - p(k-1))),
            vector(100,k,k+=6; P1_rel(k)));
}
{
check_exact(vector(100,k,k+=6;
                   22 + 2*w3
                   + (
                      p(k+6) - (21 + 2*w3) *p(k) + (22 + 2*w3) *p(k-1)
                     )
                   / ( (1-1/b) * b^k + p(k) - p(k-1))),
            vector(100,k,k+=6; P1_rel(k)));
}

check_exact(vecmax(apply(norm,p_vector)), 171)
check_exact(171, 3*3 * 19)

abs_as_quad(z) = sqrt_as_quad(real(z * conj(z)));
\\ print(vecmax(apply(abs_as_quad,p_vector)));
\\ check_exact(vecmax(apply(abs_as_quad,p_vector)), 3*sqrt_as_quad(19))


{
check_exact(vector(100,k,k+=6;
                   sqrt3
                   + z_to_y(
                   + ( p(k+6) - (21 + 2*w3) *p(k) + (22 + 2*w3) *p(k-1)
                     )
                   / ( (1-1/b) * b^k + p(k) - p(k-1)))),
            vector(100,k,k+=6; z_to_y(P1_rel(k))));
}

{
check_exact(vector(100,k,k+=6;
                   z_to_y(P1_rel(k)) >=
                   sqrt3
                   - (
                      (1 + sqrt(403) + sqrt(444)) *3*sqrt(19)
                     )
                   / ( 1/sqrt(3) * sqrt(3)^k - 2*3*sqrt(19) )
                  ),
            vector(100,k,k+=6; 1));
}
{
check_exact(sqrt(3) >=
                   ( (1 + sqrt(403) + sqrt(444)) *3*sqrt(19) )
                   / ( 1/sqrt(3) * sqrt(3)^12 - 2*3*sqrt(19) ),
            1);
}
vecmax(apply(norm,vector(12,k, p(k) - p(k-1))))
\\ exactly equal
\\ {
\\ check_exact( 1/sqrt(3) * sqrt(3)^6 >=  sqrt(243),
\\             1);
\\ }
\\ 1/sqrt(3) * sqrt(3)^6 -  sqrt(243)


vector(10,k,k+=6; norm( p(k+6) - (21 + 2*w3) *p(k) + (22 + 2*w3) *p(k-1) ))
vector(10,k,k+=6; norm( (1-1/b) * b^k + p(k) - p(k-1)))
{
vector(10,k,k+=6; norm(( p(k+6) - (21 + 2*w3) *p(k) + (22 + 2*w3) *p(k-1) )
                       / ( (1-1/b) * b^k + p(k) - p(k-1))))
}
{
vector(10,k,k+=6; 1.0*z_to_y(( p(k+6) - (21 + 2*w3) *p(k) + (22 + 2*w3) *p(k-1) )
                       / ( (1-1/b) * b^k + p(k) - p(k-1))))
}