\\ Copyright 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
read("terdragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

other_n_by_digits(n,delta) = {
  my(debug=0);
  if(n==0,return(0));
  my(v=concat([0,0],digits(n,3)),i=#v);
  if(debug,print("v=",v));
  while(i>1, if(v[i],ap=v[i];break()); i--);
  i--;  \\ ap unchanged
  while(1,
    if(debug,print("delta=",delta," ap=",ap));
    if(delta==0,break(),
       delta==ap,
             \\ x222222  +1 to (x+1)000000
             \\ stop if x+1==3-delta
             while(i>=1 && v[i]==2, v[i]=0; i--);
             if(i==0,
                if(debug,print(" no high 2 found: ",v));
                return(-1));
             v[i]++; 
             if(debug,print(" stop at ",v[i]" (incremented)")); 
             if(v[i]==3-delta,break());
             if(debug,print("switch"));
             i--;
             delta=3-delta;
             ,
       delta==3-ap,
             \\ x000000  -1 to (x-1)222222
             \\ stop if x-1==delta-1
             while(i>=1 && v[i]==0, v[i]=2; i--);
             if(i==0,
                if(debug,print(" no high 0 found"));
                return(-1));
             v[i]--; 
             if(debug,print(" stop at v["i"]="v[i]" (decremented)")); 
             if(v[i]==delta-1,break());
             i--;
             delta=3-delta;
             ,
       error("oops unrecognised delta")));
  fromdigits(v,3); \\ v;
}

{
  for(n=1,30,
     my(n_dir=dir(n));
     my(z=terdragon_point(n));
     print(n," ",digits(n,3)," ",z);
     for(d=0,2,
        my(ndv=terdragon_unpoint(z,d));
        \\ if(ndv[2] != 0, next());
        my(nd=ndv[1]);
        my(od=(-d+n_dir)%3);
        \\ if(LowestNonZero(n)==2 && od, od=3-d);
        my(o=terdragon_other_n(n,od));
        my(f=other_n_by_digits(n,od));
        my(odiff=if(o==nd,""," ***diff"));
        my(fdiff=if(f==nd,""," ***diff"));
        print("  d="d"  "ndv" o="o,odiff" f="f);
     );
  );
}
\\ n=fromdigits([2,0,0,0,1,2,2,2,2],3);
\\ n=fromdigits([2,0,0,0,1],3);
\\ n=2
\\ digits(n,3)
\\ digits(terdragon_other_n(n,1),3)
\\        other_n_by_digits(n,1)
\\ digits(terdragon_other_n(n,2),3)
\\        other_n_by_digits(n,2)
\\ vector(10,n, terdragon_other_n(n,1))
\\ vector(10,n, other_n_by_digits(n,1))

