#!/usr/bin/perl -w

# Copyright 2014, 2016, 2017, 2018 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use FindBin;
use Math::PlanePath::TerdragonRounded 117; # v.117 for level_to_n_range()

BEGIN { unshift @INC, $FindBin::Bin }
use MyTerdragon ':all';
use MyPrintwrap ':all';


my $level = 5;

print "  % generated by tools/$FindBin::Script\n";
my $path = Math::PlanePath::TerdragonRounded->new;

my ($n_lo, $n_hi) = $path->level_to_n_range($level);
$n_hi -= 1;

$Printwrap = 2;
{
  my ($x,$y) = $path->n_to_xy($n_lo);
  print "  \\node (start) at ($x,{$y*sqrt(3)}) [my dot];\n";
}
{
  my ($x,$y) = $path->n_to_xy($n_hi);
  print "  \\node (end) at ($x,{$y*sqrt(3)}) [my dot];\n";
}
printwrap("\\draw ");
my $join = '';
foreach my $n ($n_lo .. $n_hi) {

  my $p;
  if ($n == $n_lo) {
    $p = "(start)";
  } elsif ($n == $n_hi) {
    $p = "(end)";
  } else {
    my ($x,$y) = $path->n_to_xy($n);
    $p = "($x,{$y*sqrt(3)})";
  }
  printwrap("$join$p");
  $join = '--';
}
printwrap(";\n");

print "  % end generated\n";
exit 0;
